        
        
class model_small(ENode):
    
    def descent(self, cuts_fan, sample, mm_sym, data_tray):
        
        if cuts_fan.a_value.sequence:
            last =  cuts_fan.a_value.sequence[-1]
            A    = last.U_
        else:
            A      = sample[0]
        
        n = len(A)
        
        box    = Object()
        box.U_ = A[:n]
        box.n  = n
        
        return [ box ]

    def ascent(self, vcube, d_inputs, d_values):
        
        oc1  = vcube.aggg([ ('argmin', 'c'),
                            ('mean',    'sub_sample'), ])

        
        c_plain = oc1.cube.ravel()[0]
        
        n = d_values[0].n
        
        A  = d_inputs.sample[0]
        E  = d_inputs.sample[1]
        source = d_inputs.data_tray.source
        # need stratified sample
        sampler = SubSampling(sequence    = source.rows, 
                              restriction = A, 
                              mapping     = source.output_mapping,
                              seed      = 'ke',
                              #n_folds   = 3,
                              
                              )
        
        A_ = sampler.stratified_subset(n)
        
        
        d_inputs.mm_sym.set_C(2. ** (c_plain), len(A_))

        small_model = d_inputs.mm_sym.train(A_)

        Y           = d_inputs.data_tray.get_Y(E)                          
        Y_hat_small = d_inputs.mm_sym.predict(small_model,E)
        small_model.error_e = er(Y,Y_hat_small )   
        
                
        return small_model
class MMBCSO(Named):
#    def plot_data(self,X,Y, title):
#        dp = DataPlot(
#                     show_grid     = True,
#                     data_matrix   = X,
#                     output_vector = Y, 
#                     title         = title,
#                     #lines         = lines[i], 
#                     #line_colors   = ['b'],
#                     #line_text     = [str(a) for a in I(lines[i])],
#                         )
#        dp.go()

      
    def report_on_optimization(self,opt_output, Q, Q_, X):
        v, value, n_f_eval, n_grad_eval, unknown, steps = opt_output
        (n,d)    = shape(X)
        
        self.send("v[:4] :", v[:4])
        self.send("n,d   :", n,d)
        self.send("rho   :", linalg.norm(v[:-1],ord=1))
        self.send("eta   :", linalg.norm(v[:-1],ord=1)/d)
        self.send("b     :", v[-1])
        self.send()


        if 0:
            for step in steps:
                w = step[:-1]
                b = step[-1]
                
                nw = linalg.norm(w)
                w_ = w/nw
                b_ = b/nw
                self.send()
                self.send("Here:", step)
                self.send("Grad:", Q_(step) )
                self.send("Value:", Q(step))
                self.send("Geometrically:", w_, b_)
                self.send() 
 
 
     def set_alpha(self, a, c_reg):
        
        dummy_objective = self.objective_class()
        n_losses        = len(dummy_objective.losses)
        n_regulizers    = len(dummy_objective.regulizers)
        c_reg_ = c_reg*2**a
        
        self.weights    = [  c_reg_ ] * n_regulizers + [ 1. ] * n_losses
                
class MMBCSO2(MMBCSO):
    def init(self,
             apply_BR = True):
        pass

  
class BCSOModel(LLMM):
    

    def get_value(self, R):
        M = self
        
        
        
        #print R
        n_R= len(R)
        K_cross  = M.K[:,R]
        #print "DDD", len(R),shapes(M.X, K_cross, M.B)
        
        X_    = dot(M.B, K_cross).transpose()
        
        g          = dot(X_, col(M.beta))
        f          = g - M.b
        Y = M.Y[R,:]
        #print "VVV", shapes(X_,g,f,Y,M.sign)
        m  = M.sign * col(Y) * col(f)
        
        xi = col(concatenate((zeros((n_R,1)), 1 - m), axis=1).max(axis=1))
        xi_avg = sum(xi,axis=0).ravel()[0]/n_R
        
        #print 'GGG'
        #print  concatenate((m,xi), axis=1)
    
        gamma = self.get_gamma()
        xi_avg_geom = xi_avg*gamma
        g_term      = 0.0002 * 1./gamma    
        
        print 'gamma:      ', gamma
        print 'xi_avg:     ', xi_avg
        print 'xi_avg_geom:', xi_avg_geom
        print 'g-term:     ', g_term
        
        
        return xi_avg_geom + g_term   

        #X_test_    = dot(M.B, K_cross).transpose()
        #g          = dot(X_test_, col(M.beta))
        
        #y_hat      = col(a2sign(f))
        #gm         = f / linalg.norm(M.beta) 
        
        #X,Y = self.maker.data_tray.get_XY(R)
        #g = col(dot(X_, col(self.beta)))
        #f = g - M.b
        
