
from peewit.presentation import Viewer 
from peewit.vcubes import VCube


from project_conf import *

VCube.pathkeeper = PK

if 1:
    #r = AR.get_run_by_number('1a0cd320a2')
    #print r
    #AR.restore()
    #AR.restore('3aefebe090')

    #AR.store_run_iot()
    AR.export_project()
    #AR.export_project()
    pass

# dp
if 0:

    vc  = VCube(basename='et_dp--2__test--frequency--plain')

    #vc.save()
    vc = vc.aggg([('mean','sample')])
    
    
    print vc.run_number
    
    vc.partially_permute(['data_source', 'kernel',  'distance' ] )    
    
    vi = Viewer(vc)    

    vi.print_vcube(fixed_length=4)
    
    plots = vi.build_plots(show_grid=False,
                           markersize=1,
                           x_margin=0.01
                           )
    
    vi.save_plots(plots)

# ib
if 0:
    vc  = VCube(basename='et_ib--2--ib_eval--main')
    #vc  = VCube(basename='et_ib--0__test--ib_eval--plain')

    
    vc = vc.aggg([('mean','sample')])
    #vc2 = vc.aggg([('std','sample')])
    vc.partially_permute(['ib_eval', 'data_source', 'kernel' ] )    
    vc = vc.aggg([('sel', 'ib_eval', 'error_rate') ])
    vi = Viewer(vc)
    vi.print_vcube(fixed_length=5)
    #vi.latex_table_snippet(['data_source'], ['kernel'])


# baseline
if 0:

    #vc  = VCube(basename='svm_et--4__test--leaf_final--plain')
    vc  = VCube(basename='svm_et--9e--leaf_final--main')

    
    vc = vc.aggg([('mean','sample')])
    #vc2 = vc.aggg([('std','sample')])
    vc.partially_permute(['leaf_final', 'data_source', 'kernel' ] )    
    vc = vc.aggg([('sel', 'leaf_final', 'error_rate') ])
    vi = Viewer(vc)
    vi.print_vcube(fixed_length=5)
    vi.latex_table_snippet(['data_source'], ['kernel'])


# full
if 0:
    vc  = VCube(basename='etree_sgo--10_cheat_ce__test--eval_sequence--plain')
    vc  = VCube(basename='etree_sgo--10_cheat_ce--eval_sequence--main')
    
    vc = vc.aggg([('mean','sample')])
    
    
    print vc.run_number
    vc = vc.aggg([('del', 'eval_sequence', 'min_res', 'min_res_E' ), 
    #             ('sel', 'kernel', 'poly_2'),
                  ])
    part = 'del_mins_p2'
    vc.pathkeeper.partname = part
    
    vc.partially_permute(['kernel', 'data_source', 'eval_sequence' ] )    
    vc.save()
    
    vi = Viewer(vc)    

    vi.print_vcube(fixed_length=5)
    
    vi.latex_table_snippet(['kernel','data_source'])
    

# rcrs
if 0:

    #vc  = VCube(basename='etree_sgo--3--eval_sequence--main')
    #vc  = VCube(basename='etree_sgo--6__test--eval_sequence--plain')
    #vc  = VCube(basename='etree_rcrs--0__test--eval_sequence--plain')
    vc  = VCube(basename='etree_rcrs--11--eval_rcrs--main')

    #vc.save()
    vc = vc.aggg([('mean','sample')])
    
    
    print vc.run_number
    vc = vc.aggg([('del', 'eval_rcrs', 'error_cut' )] )
    part = 'd_es'
    #vc.pathkeeper.partname = part
    #vc.save()
    
    vc.partially_permute(['kernel', 'data_source', 'eval_rcrs' ] )    
    
    vi = Viewer(vc)    

    vi.print_vcube(fixed_length=5)
    
    vi.latex_table_snippet(['kernel','data_source'])
    

# rcrs_d
if 0:

    #vc  = VCube(basename='etree_sgo--3--eval_sequence--main')
    #vc  = VCube(basename='etree_sgo--6__test--eval_sequence--plain')
    vc  = VCube(basename='etree_rcrs_d--5__test--reached_fraction--plain')
    #vc  = VCube(basename='etree_rcrs_d--4--reached_fraction--plain')

    #vc.save()
    vc = vc.aggg([('mean','sample'),
                  ('sel', 'kernel', 'poly_2')
                  ])
    
    
    print vc.run_number
    
    #vc.partially_permute(['kernel', 'data_source', 'eval_rcrs' ] )    
    
    vi = Viewer(vc)    

    vi.print_vcube(fixed_length=4)
    
    plots = vi.build_plots(show_grid=False,
                           markersize=1,
                           x_margin=0.01
                           )
    
    vi.save_plots(plots)
    #vi.latex_table_snippet(['kernel','data_source'])
    
    
    
    
if 0:
    
    PK.treename      = 'etree_sgo'
    PK.version       = 'c4'
    PK.target_ename  = 'eval_simple'
    PK.partname      = 'main'
    
    vc = VCube(pathkeeper=PK)

    
    vc.aggregations([('sample','mean')])    
   
 
    vc.partially_permute(['c_reg_cut','eval_simple'])
    
    part = 'linear'
    
    sel1 = {
             'eval_simple': [ 'error_total' ],
             #'data_source': ['sonar'], 
             'kernel':[part], 
             'number_of_cuts':['0'],
             'cut_objective' : ['SecoObjectiveA']
            }
    
    vc.pathkeeper.partname = part
    
    vc1 = vc.selections(sel1, inline=False)
    
    vc1 = vc1.repeat_singleton('c_reg_cut')
    
    vc1.value_names['cut_objective'] = ['baseline']

    vi  = Viewer(vc1,)
    vi.print_vcube()
    
    #ag  = [ ('c_reg_cut','argmin'), ]
    #vi.print_with_marked_argaggregations(ag, marker='*', fixed_length=5)
        
    
    sel2 = {} 
    sel2.update(**sel1)
    sel2['cut_objective']  = []
    sel2['number_of_cuts'] = ['32']
    
    vc2 = vc.selections(sel2, inline=False)
    
    vi  = Viewer(vc2,)
    vi.print_vcube()
    
    vc3 = VCube.merge_vcubes([vc2,vc1], ename='cut_objective')
    vi  = Viewer(vc3,)
    vi.print_vcube()
    
    
    vi.save_plots(show_grid=False,
                  markersize=1)

    
 


if 0: 

    for c_reg_cut in ['-11', '-10', '-9', '-8', '-7', '-6']:
        for kernel in ['linear', 'poly_2_1.0']:
            vc_ = vc.selections( {'c_reg_cut' : [ c_reg_cut], 'kernel':[kernel] },
                            by_names=True, inline=False)
            
            vi = Viewer(vc_, mention_only= ['data_factory', 
                                            'c_reg_cut', 
                                            'kernel',
                                            'number_of_cuts'],
                            drob_header_1=1
                                            )
            vi.print_vcube()
            
            
    