


from peewit.presentation import Viewer
from peewit.vcubes import VCube

from svm_en import *
from project_conf import PK


VCube.pathkeeper = PK


if 1:
    
    vc1  = VCube(basename='spb_et--4__test--eval--plain')
    vc2  = VCube(basename='spb_et--4__test--data_values--plain')
        
    vc2l = vc2.extract_member('llb')
    vc2u = vc2.extract_member('lub')
    
    
        
    vc1 = vc1.aggg([ ('del','eval','epsilon_avg_v'),
                ])
    vc1  = vc1.aggg([('mean','sample')])
    
    vc2l = vc2l.aggg([('mean','sample')])
    vc2u = vc2u.aggg([('mean','sample')])

    #vc2 = vc.aggg([('std','sample')])

    #vc1.shrink(['c','eval'])

    #vc.pathkeeper.version = 'pp32seed'
        
    vi = Viewer(vc1)
    
    vcp = vi.build_plots( ['data_source','eval','c'],
                           markersize=0.5, 
                           show_grid=0,
                           x_margin=0.0,
                           y_margin=0.04
                        )
    
    vc2l = vcp.align_dims(vc2l)
    vc2u = vcp.align_dims(vc2u)
    
    
    def add_c_bounds(p, c):
        p.add_vertical_line(p,c,ls='--',lw=0.5)
        p.add_horizontal_line(p,0,ls='-')
        
    
        
    vcp.map(vc2l, add_c_bounds)
    #vcp.map(vc2u, add_c_bounds)
    #quit()
    
    vi.save_plots(vcp)
    
    vi = Viewer(vcp)
    vi.print_vcube(fixed_length=5)
    
    vi = Viewer(vc2)
    vi.print_vcube(fixed_length=5)
    
    
    
    
    
    


    
