


from peewit.presentation import Viewer
from peewit.vcubes import VCube


from project_conf import PK
from svm_en import *
from tb.plotting import FunctionPlot
import pylab

VCube.pathkeeper = PK


if 1:
    
    
    
    A1 = range(1,16) 
    A2 = [ 2**b for b in A1 ]

    def G1(a):
        def h(t):
            return t**a
        return h

    def G2(a):
        def h(t):
            return (a**t - 1.)/(a-1)
        return h

    
    F1 = [ G1(a) for a in A1 ]
    F2 = [ G2(a) for a in A2 ]
    
    K1 = [ '$t^{' + str(a) + '}$' for a in A1 ]

    K2 = [ r'$\rho^{\exp}_{' + str(a) + '}$' for a in A2 ]


    T1 = r'$\rho^{\mathrm{pol}}$'    
    T2 = r'$\rho^{\exp}$'
    
    fp = FunctionPlot(functions =F1,
                      title     =T1,
                      keys      =K1,
                      x_interval=[0,1],
                      x_margin=0.,
                      y_margin=0.,
                      x_label  = '$t$',
                      y_label  = r'$\rho $',
                      
                      colors   = ['b'] * len(A1),
                      show_legend = 0,
                      tick_max=0,
                      tick_argmax=0,
                      x_ticks=[0,1],
                      y_ticks=[1], 
                      )
    fp.go()
    
    pylab.show()