
from scipy import random, concatenate


from ml.libsvm import LIBSVM
from ml.data import DataSource, vote

from scipy import array, nan, shape, dot   ,inf   , mean, random                                                                                                                                                             


from tb.fileaccess import homedir
from tb.mixedtools import tok

run_dir    = homedir + 'gebiete/lmsc/run/'           
out_dir    = run_dir + 'output/'


tray = DataSource(data_factory = vote())

X, Y = tray.get_XY(range(400))


X = X - mean(X, axis=0)
#print X,Y


tray.X = X



n    = len(X)
Z    = range(n)
seed  = 'Herbert'
random.seed([ord(x) for x in seed])
random.shuffle(Z)

S    = Z[ :int(n*0.7) ]
T    = Z[ int(n*0.7): ]
#print Z


def count_sign(y,s):
	return sum( s * y > 0 )


engine = LIBSVM(
			    	data_tray    = tray,
    			    kernel_type = 'poly',
    			    g           = 1, 
    			    c           = 3.4,
                    C           = 0.1,
                    sigma       = 2.,
                    l           = 2,
                )

print tok('start train default')
model_va  = engine.train(S)
print tok('end train default')
#model_wb  = engine.train_wb(S)
print tok('start train bb')
model_bb  = engine.train_betab(S)
print tok('end train bb')



print tok('training')

#print model_bb

y_hat_va, f_va, s_va  = engine.predict(model_va, T, get_scores=True, get_scale=True)
print tok(4)
#y_hat_wb, f_wb, s_wb  = engine.predict_wb(model_wb, T, get_scores=True, get_scale=True)
y_hat_bb, f_bb, s_bb  = engine.predict_betab(model_bb, T, get_scores=True, get_scale=True)
print tok('prediction')



print len(y_hat_va)
#print sum(sum(array(y_hat_va == y_hat_wb))) 
print sum(sum(array(y_hat_va == y_hat_bb)))

#print shapes(f_va, f_wb, f_bb)
#print concatenate(( f_va, f_bb), axis=1)
print (s_va, s_bb)

#print beta
print count_sign(Y, -1)
#print tray.X[S]

#assert sum(sum(array(y_hat_va == y_hat_wb))) == len(y_hat_va)
assert sum(sum(array(y_hat_va == y_hat_bb))) == len(y_hat_va)


